//
//  main.cpp
//  PointerRefs
//
//  Created by Heinrich Hussmann on 17.04.16.
//  Copyright © 2016 Heinrich Hussmann. All rights reserved.
//

#include <iostream>

int main(int argc, const char * argv[]) {
    
    // two integer variables
    int myvar1 = 25;
    int myvar2 = 50;
    
    // a reference to (the address of) variable myvar
    int& adr = myvar1;
    
    // a pointer pointing to the address of variable myvar
    int* ptr = &myvar1;
    
    std::cout << "Step 1 - Value of myvar1: " << myvar1 << std::endl;
    std::cout << "Step 1 - Value of myvar2: " << myvar2 << std::endl;
    std::cout << "Step 1 - Value of adr: " << adr << std::endl;
    std::cout << "Step 1 - Value of ptr: " << ptr << std::endl;
    std::cout << "Step 1 - Value of *ptr: " << *ptr << std::endl;
    
    // assign new value to variable through reference
    adr = 99;

    std::cout << "Step 2 - Value of myvar1: " << myvar1 << std::endl;
    std::cout << "Step 2 - Value of myvar2: " << myvar2 << std::endl;
    std::cout << "Step 2 - Value of adr: " << adr << std::endl;
    std::cout << "Step 2 - Value of ptr: " << ptr << std::endl;
    std::cout << "Step 2 - Value of *ptr: " << *ptr << std::endl;
    
    // assign the pointer to another variable
    ptr = &myvar2;
    
    std::cout << "Step 3 - Value of myvar1: " << myvar1 << std::endl;
    std::cout << "Step 3 - Value of myvar2: " << myvar2 << std::endl;
    std::cout << "Step 3 - Value of adr: " << adr << std::endl;
    std::cout << "Step 3 - Value of ptr: " << ptr << std::endl;
    std::cout << "Step 3 - Value of *ptr: " << *ptr << std::endl;
    
    
    

    return 0;
}
